int ECRAN_LARG = 800;
int ECRAN_HAUT = 600;

int x_cible=10;
int y_cible=10;
int larg_cible=100;
int haut_cible=100;

int OUT=0;
int OVER=1;
int DRAG=2;

int taille_icone = 20;

color cl_out = color(200, 200, 200);
color cl_over = color(100, 100, 100);
color cl_drag = color(0, 0, 0);

PImage img_mona;
boolean isBoxIn;

class Box
{
  int x;
  int y;
  int larg;
  int haut;

  Box(int x , int y, int larg, int haut)
  {
    this.x = x;
    this.y = y;
    this.larg = larg;
    this.haut = haut;
  }

  void dessine(){
    rect(x, y, larg, haut);
  }
}

class Icone extends Box{
  int etat;
  color couleur;

  Icone(int x , int y, int larg, int haut){
    super(x,y,larg,haut);
    this.etat=OUT;
  }

  void dessine(){
    switch(etat){
    case 0:
      couleur=cl_out;
      break;
    case 1:
      couleur=cl_over;
      break;
    case 2:
      couleur=cl_drag;  
      break;
    }
    fill(couleur);
    super.dessine();
  }
}

Icone movable;
Box cible;

void setup() {
  size(ECRAN_LARG, ECRAN_HAUT);
  movable = new Icone(width/2, height/2, taille_icone, taille_icone);
  cible = new Box(x_cible, y_cible, larg_cible, haut_cible);
  img_mona = loadImage("mona.jpg");
  imageMode(CENTER);
  isBoxIn=false;
  noLoop();
}

void draw(){
  //Dessine les elements de l'appli
  //Peint le fond de la fenetre
  background(255); 
  //Si l'icone est dans la cible, affiche l'image
  if(isBoxIn)
    image(img_mona, width/2, height/2);
  //Dessine les boites
  noFill();
  cible.dessine();
  movable.dessine();
}

//Retourne TRUE si le point "A" se trouve dans le rectable "B"
//On l'utilise pour detecter si le curseur se trouve sur l'icone...
//... mais aussi pour voir si l'icone se trouve dans la grande boite
boolean A_dans_B(int x_A, int y_A, int x_B, int y_B, int l_B, int h_B){
  if( (x_A>x_B && x_A<(x_B+l_B)) && (y_A>y_B && y_A<(y_B+h_B)) )
    return true;
  else
    return false;
}

//Lorsque le curseur bouge on verifie s'il ne s'arrete pas sur l'icone
void mouseMoved(){
  if( A_dans_B(mouseX, mouseY, movable.x, movable.y, movable.larg, movable.haut) ){
    movable.etat=OVER;
  }
  else{
    movable.etat=OUT;
  }
  redraw();
}

//Si on clique et le curseur est sur l'icone, l'icone entre dans l'etat DRAG
void mousePressed(){
  if(A_dans_B(mouseX, mouseY, movable.x, movable.y, movable.larg, movable.haut) ){
    movable.etat=DRAG;
    redraw();
  }
}

//Lorsqu'on lache le bouton, DRAG n'est plus vrai, voir quel est le nouvel etat
void mouseReleased(){
  //Verifie le nouvel etat de l'icone
  if(movable.etat==DRAG){
    movable.etat=OVER;
    //verifie si la boite a ete deposee dans la cible
    if(A_dans_B(movable.x, movable.y, cible.x, cible.y, cible.larg, cible.haut))
      isBoxIn=true;
    else
      isBoxIn=false;
  }
  else
    movable.etat=OUT;
  //verifie si la boite a ete depose
  redraw();
}

//Incremente la position de l'icone si l'icone est dans l'etat DRAG
void mouseDragged(){
  if(movable.etat==DRAG){
    movable.x+=(mouseX-pmouseX);
    movable.y+=(mouseY-pmouseY);
    redraw();
  }
}
