int ECRAN_LARG = 800;
int ECRAN_HAUT = 600;
int taille_slider = 16;

int OUT=0;
int OVER=1;
int DRAG=2;

color cl_out = color(200, 200, 200);
color cl_over = color(100, 100, 100);
color cl_drag = color(0, 0, 0);

PImage img_mona;
float echelle;

class Box
{
  int x;
  int y;
  int larg;
  int haut;
  int x_centre;
  int y_centre;

  Box(int x , int y, int larg, int haut)
  {
    this.x = x;
    this.y = y;
    this.larg = larg;
    this.haut = haut;
    this.x_centre = larg/2;
    this.y_centre = haut/2;
  }
  
  void dessine(){
    rect(x, y, larg, haut);
  }
}

class Slider extends Box{
  int etat;
  color couleur;
  int x_min;
  int x_max;

  Slider(int x , int y, int larg, int haut, int x_min, int x_max){
    super(x,y,larg,haut);
    this.etat=OUT;
    this.x_min=x_min;
    this.x_max=x_max;
  }

  void dessine(){
    switch(etat){
    case 0://on devrait utiliser ici les constantes OUT, OVER et DRAG
      couleur=cl_out;
      break;
    case 1://on devrait utiliser ici les constantes OUT, OVER et DRAG
      couleur=cl_over;
      break;
    case 2://on devrait utiliser ici les constantes OUT, OVER et DRAG
      couleur=cl_drag;  
      break;
    }
    fill(couleur);
    //dessine le rail sur lequel le slider glisse
    line(x_min, y+(taille_slider/2), x_max+taille_slider, y+(taille_slider/2));
    super.dessine();
  }
  
  float getValue(){
    //Normalise x (entre 0 et 1) 
    float val_temp=norm(x, x_min, x_max);
    //Mappe la sortie pour qu'elle varie dans une plage qui convient a la fonction exponentiel
    val_temp = map(val_temp, 0.0, 1.0, -3, 3);
    val_temp=exp(val_temp);
    return(val_temp);
  }
}

Slider movable;

void setup() {
  size(ECRAN_LARG, ECRAN_HAUT);
  movable = new Slider(ECRAN_LARG/2, ECRAN_HAUT-50, taille_slider, taille_slider, 10, (ECRAN_LARG-50));
  img_mona = loadImage("mona.jpg");
  imageMode(CENTER);
  noLoop();
}

void draw(){
  //recupere la velur du slider qui est utilise pour definir l'echelle de l'image
  echelle=movable.getValue();
  //Dessine les elements de l'appli
  background(255);
  image(img_mona, width/2, height/2, img_mona.width*echelle, img_mona.height*echelle);
  noFill();
  movable.dessine();
}

//Retourne TRUE si le point "A" se trouve dans le rectable "B"
boolean A_dans_B(int x_A, int y_A, int x_B, int y_B, int l_B, int h_B){
  if( (x_A>x_B && x_A<(x_B+l_B)) && (y_A>y_B && y_A<(y_B+h_B)) )
    return true;
  else
    return false;
}

void mouseMoved(){
  if( A_dans_B(mouseX, mouseY, movable.x, movable.y, movable.larg, movable.haut) ){
    movable.etat=OVER;
  }
  else{
    movable.etat=OUT;
  }
  redraw();
}

void mousePressed(){
  if(A_dans_B(mouseX, mouseY, movable.x, movable.y, movable.larg, movable.haut) ){
    movable.etat=DRAG;
    redraw();
  }
}

void mouseReleased(){
  if(movable.etat==DRAG)
    movable.etat=OVER;
  else
    movable.etat=OUT;
  redraw();
}

void mouseDragged(){
  if(movable.etat==DRAG){
    movable.x+=(mouseX-pmouseX);
    movable.x=constrain(movable.x, movable.x_min, movable.x_max);
    redraw();
  }
}
